package com.jz.common.interceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.MDC;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import com.jz.common.constant.CommConstant;
import com.jz.common.utils.CodeGeneratorUtils;

/**
 * @ClassName: LogInterceptor
 * @Description: TODO(日志MDC)
 * @author ybz
 * @date 2021年1月25日
 *
 */
public class LogInterceptor implements HandlerInterceptor {
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //如果有上层调用就用上层的ID
        String traceId = request.getHeader(CommConstant.TRACE_ID);
        if (traceId == null) {
            traceId = CodeGeneratorUtils.generatorTraceId();
        }

        MDC.put(CommConstant.TRACE_ID, traceId);
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView)
            throws Exception {
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)
            throws Exception {
        //调用结束后删除
        MDC.remove(CommConstant.TRACE_ID);
    }
}