package com.jz.dmp.modules.dao;

import com.jz.dmp.modules.model.DmpNavigationTree;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * DMP资源导航树(DmpNavigationTree)表数据库访问层
 *
 * @author makejava
 * @since 2020-12-29 15:08:16
 */
public interface DmpNavigationTreeDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DmpNavigationTree queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<DmpNavigationTree> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param dmpNavigationTree 实例对象
     * @return 对象列表
     */
    List<DmpNavigationTree> queryAll(DmpNavigationTree dmpNavigationTree);

    /**
     * 新增数据
     *
     * @param dmpNavigationTree 实例对象
     * @return 影响行数
     */
    int insert(DmpNavigationTree dmpNavigationTree) throws Exception;

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpNavigationTree> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<DmpNavigationTree> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpNavigationTree> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<DmpNavigationTree> entities);

    /**
     * 修改数据
     *
     * @param dmpNavigationTree 实例对象
     * @return 影响行数
     */
    int update(DmpNavigationTree dmpNavigationTree);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int countTreeByName(DmpNavigationTree tree);

    /**
     * @param @param  projectId
     * @param @param  name
     * @param @return
     * @param @throws Exception    参数
     * @return DmpNavigationTree    返回类型
     * @throws
     * @Title: getByProjectIdAndName
     * @Description: TODO(根据项目ID和任务名称获取tree)
     */
    public DmpNavigationTree getByProjectIdAndName(@Param("projectId") Long projectId, @Param("name") String name) throws Exception;

    /**
     * @param @param  tree
     * @param @return
     * @param @throws Exception    参数
     * @return Integer    返回类型
     * @throws
     * @Title: getMaxSortById
     * @Description: TODO(这里用一句话描述这个方法的作用)
     */
    public Integer getMaxSortById(DmpNavigationTree tree) throws Exception;

    /**
     * 选择性增加DMP资源导航树
     *
     * @param dmpNavigationTree
     * @return
     * @throws Exception
     */
    public int insertSelective(DmpNavigationTree dmpNavigationTree) throws Exception;

    /**
     * 假删除任务树
     *
     * @param params 查询起始位置
     * @return
     * @Date 2021/02/03
     */
    int deleteByTreeId(Map params) throws Exception;

    /**
     * 获取 flowId/任务名称
     *
     * @return
     * @author Bellamy
     * @since 2021-03-08
     */
    List<Map> queryTaskFlowId(String projectId) throws Exception;
}