package com.jz.dmp.modules.service;


import com.jz.common.constant.JsonResult;
import com.jz.dmp.modules.model.DmpSyncingDatasourceType;

import java.util.List;

/**
 * 数据源类型(DmpSyncingDatasourceType)表服务接口
 *
 * @author Bellamy
 * @since 2020-12-29 19:24:05
 */
public interface DmpSyncingDatasourceTypeService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DmpSyncingDatasourceType queryById(Integer id);

    /**
     * 查询多条数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<DmpSyncingDatasourceType> queryAllByLimit(int offset, int limit);

    /**
     * 新增数据
     *
     * @param dmpSyncingDatasourceType 实例对象
     * @return 实例对象
     */
    DmpSyncingDatasourceType insert(DmpSyncingDatasourceType dmpSyncingDatasourceType);

    /**
     * 修改数据
     *
     * @param dmpSyncingDatasourceType 实例对象
     * @return 实例对象
     */
    DmpSyncingDatasourceType update(DmpSyncingDatasourceType dmpSyncingDatasourceType);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取数据源——下拉框
     *
     * @return
     * @since 2021-01-21
     * @author Bellamy
     */
    JsonResult queryDatasourceList() throws Exception;
}