package com.jz.dmp.modules.service.sys;

import javax.servlet.http.HttpServletRequest;

import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleBatch;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleDto;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleRequest;
import com.jz.dmp.modules.controller.sys.bean.MembProjRoleBatchReq;
import com.jz.dmp.modules.model.DmpMemberProjectRole;

/**
 * 用户项目角色表服务接口
 * @author ybz
 *
 */
public interface DmpMemberProjectRoleService {

	/**条件分頁查询所有用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpMemberProjectRoleDto> findListWithPage(DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpMemberProjectRoleDto> findList(DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest)throws Exception;

	

	/**新增用户项目角色表
	 * @param dmpMemberProjectRole
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpMemberProjectRole> add(DmpMemberProjectRole dmpMemberProjectRole, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询用户项目角色表
	 * @param memberProjectRoleId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpMemberProjectRoleDto> findById(Integer memberProjectRoleId, HttpServletRequest httpRequest)throws Exception;

	/**修改用户项目角色表
	 * @param dmpMemberProjectRole
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpMemberProjectRole> edit(DmpMemberProjectRole dmpMemberProjectRole, HttpServletRequest httpRequest)throws Exception;

	/**主键删除用户项目角色表
	 * @param memberProjectRoleId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer memberProjectRoleId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除用户项目角色表
	 * @param memberProjectRoleId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer memberProjectRoleId, HttpServletRequest httpRequest)throws Exception;

	/**批量新增用户项目角色表
	 * @param dmpMemberProjectRoleVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpMemberProjectRoleBatch> addBatch(DmpMemberProjectRoleBatch dmpMemberProjectRoleBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: addProjMembers  
	* @Description: TODO(批量新增项目成员)  
	* @param @param membProjRoleBatchReq
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseBeanResponse<DmpMemberProjectRole>    返回类型  
	* @throws  
	*/ 
	public BaseBeanResponse<DmpMemberProjectRole> addProjMembers(MembProjRoleBatchReq membProjRoleBatchReq,
			HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest)throws Exception;

}
